// serverDlg.cpp : implementation file
//
#include "stdafx.h"
#include "server.h"
#include "serverDlg.h"
#include <atlimage.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyserverDlg dialog

CMyserverDlg::CMyserverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyserverDlg::IDD, pParent)
	, m_dwThreadReceiveId(0)
	, m_szFrameSpeed(_T(""))
	, m_szBoardIP(_T(""))
	, m_szPCIP(_T(""))
{
	//{{AFX_DATA_INIT(CMyserverDlg)
	m_szRecv = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMyserverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyserverDlg)
	DDX_Text(pDX, IDC_EDIT1, m_szRecv);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDIT2, m_szFrameSpeed);
	DDX_Text(pDX, IDC_EDIT3, m_szBoardIP);
	DDX_Text(pDX, IDC_EDIT4, m_szPCIP);
}

BEGIN_MESSAGE_MAP(CMyserverDlg, CDialog)
	//{{AFX_MSG_MAP(CMyserverDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()	
	ON_WM_TIMER()
	//}}AFX_MSG_MAP	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyserverDlg message handlers

#include<winsock2.h>

BOOL CMyserverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();	
	/*
	m_hThreadReceive = CreateThread( 
    NULL,						
    0,							
    ThreadFuncReceive,  		
    this,						
    CREATE_SUSPENDED,
    &m_dwThreadReceiveId);		
	::SetThreadPriority(m_hThreadReceive, THREAD_PRIORITY_HIGHEST);
	ResumeThread(m_hThreadReceive);
	*/	
	_beginthread(ThreadFuncReceive, 0, this);

	SetTimer(2,1000,NULL);
	
	//m_szPCIP = CString("{IPF")+"192.168.0.60";

	WSADATA wsaData;
	char name[155];
	char *ip;
	PHOSTENT hostinfo; 
	if ( WSAStartup( MAKEWORD(2,0), &wsaData ) == 0 ) { 
		if( gethostname ( name, sizeof(name)) == 0) { 
			if((hostinfo = gethostbyname(name)) != NULL) { //?A?IPI
				ip = inet_ntoa (*(struct in_addr *)*hostinfo->h_addr_list); 
				//MessageBox(ip);
				m_szPCIP = ip;
			} 
			else
			{
				MessageBox(_T("gethostbyname error"));
			}
		} 
		else
		{
			MessageBox(_T("gethostname error"));
		}
		WSACleanup( );
	}
	else
	{
		MessageBox(_T("WSAStartup error"));
	}

	return TRUE; // return TRUE unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CMyserverDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);		
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CMyserverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMyserverDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	this->UpdateData(FALSE);	
	CDialog::OnTimer(nIDEvent);
}

#define BUF_SIZE 1024*1024

//DWORD ThreadFuncReceive(LPVOID lpParam)
void ThreadFuncReceive(LPVOID lpParam)
{	
	char *szRecv = new char[BUF_SIZE];
	int iRecvBytes = 0;		
	UINT uPort=6800;
	HGLOBAL hGlobal;
	void * pData;
	IStream * pStream = NULL;
	CImage image;

	static int iTotalBytes=0,iTempBytes=0;
	static int iTimesOf5Seconds = 0, nFrames=0,nTotalFrames=0;
	static DWORD nMSceonds=0;
	static bool m_bThreadReceiveExist = false;
	
	if(m_bThreadReceiveExist)	
		//return -1;
		return;
	else
		m_bThreadReceiveExist = TRUE;

	if (lpParam == NULL)	return; //return -1;
	CMyserverDlg* pserverDlg = (CMyserverDlg*)lpParam;
		
	SetTimer(NULL,1,50,NULL);	//?,?ms
	
	//n
	CDC *dc = pserverDlg->GetDC();
	hGlobal = GlobalAlloc(GMEM_MOVEABLE, BUF_SIZE);
	
	CSocket m_sockRecv;
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		//return FALSE;
		return;
	}
	m_sockRecv.Create(6801,SOCK_DGRAM,pserverDlg->m_szPCIP);
	m_sockRecv.Bind(6801,pserverDlg->m_szPCIP);

	//CString szBoardIP = pserverDlg->m_szBoardIP;

	MSG	msg;	
	PeekMessage(&msg,  NULL,  NULL,  NULL,  FALSE);		//PeekMessage:?n?????
	while(GetMessage(&msg,  NULL,  NULL,  NULL))
	{  
		if(msg.message==WM_TIMER)			
		{
			
			//if((iRecvBytes = m_sockRecv.ReceiveFrom(szRecv,BUF_SIZE,szBoardIP,uPort,0)) <= 0)
			if((iRecvBytes = m_sockRecv.ReceiveFrom(szRecv,BUF_SIZE,pserverDlg->m_szBoardIP,uPort,0)) <= 0)
			{
				pserverDlg->MessageBox(_T("received error!\n"));
				delete []szRecv;
				return;
			}
			iTotalBytes += iRecvBytes;
			pData = GlobalLock(hGlobal);
			memcpy(pData, szRecv, iRecvBytes);
			GlobalUnlock(hGlobal);
			
			pStream = NULL;
			if(CreateStreamOnHGlobal(hGlobal, FALSE, &pStream) == S_OK){				
				image.Destroy();				
				if (SUCCEEDED(image.Load(pStream))){					
					//image.Draw(dc->m_hDC, 10, 60, 800,800, 0, 0, 800, 800);
					//image.BitBlt(dc->m_hDC, 10, 60, 800,800, 0, 0, SRCCOPY);
					image.StretchBlt(dc->m_hDC, 10, 70, 720,576, SRCCOPY);
				}
				pStream -> Release();
			}

			//???			
			if(GetTickCount() - nMSceonds >= 1000){		//each one second
				//cout<<nFrames;
				pserverDlg->m_szFrameSpeed.Format(_T("bԃt[F%dCt[F%d"),nFrames,nTotalFrames);
				pserverDlg->m_szRecv.Format(_T("t[F%d KBCf[^[gF%d KB/sCf[^ʁF%d KB"), iRecvBytes>>10,(iTotalBytes-iTempBytes)>>10,iTotalBytes>>10);
				nFrames=0;
				nMSceonds=GetTickCount();
				iTempBytes = iTotalBytes;				
			}
			nFrames++;
			nTotalFrames++;
		}
	}	
	GlobalFree(hGlobal);
	
	delete []szRecv;
	KillTimer(NULL,1);
	
	m_bThreadReceiveExist = false;
	//return 0;
	return;
}